package jp.co.celestee.ai.interfaces;

import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.ai.interfaces.input.AbstractDataCooperationSignal;
import jp.co.celestee.ai.interfaces.input.AbstractEnvironmentSensibleSignal;
import jp.co.celestee.ai.interfaces.input.AbstractPhysicalSensibleSignal;
import jp.co.celestee.external.rule.RuleDataIF;

public abstract class AbstractSubstance{

	/**
	 * [̓͂e֓`B
	 * @param ruleData
	 */
	public void inputDataFromRule(RuleDataIF ruleData) {
		Signals signals = new Signals();
		
		if(ruleData == null) return;
		
		inputFromRule(ruleData, signals);
		
		process(signals);
		
		outputToAI(signals);
		
		outputToRule(signals);
		
	}
	
	/**
	 * AI̓͂e֓`B
	 * @param ruleData
	 */
	public void inputDataFromAI(Object aiData) {
		Signals signals = new Signals();

		//aiDataNULLłOK
		
		inputFromAI(aiData, signals);
		
		process(signals);
		
		outputToAI(signals);
		
		outputToRule(signals);
		
	}

	/**
	 * [̓
	 * @param ruleData
	 * @param dcsignal
	 * @param esSignal
	 * @param psSignal
	 */
	abstract public void inputFromRule(
			RuleDataIF ruleData,
			Signals signals
			);

	/**
	 * AI̓
	 * @param ruleData
	 * @param dcsignal
	 * @param esSignal
	 * @param psSignal
	 */
	abstract public void inputFromAI(
			Object aiData,
			Signals signals
			);

	/**
	 * C̎s
	 * @param dcsignal
	 * @param esSignal
	 * @param psSignal
	 */
	abstract public void process(
			Signals signals
			);

	/**
	 * [ւ̏o
	 * @param dcsignal
	 * @param esSignal
	 * @param psSignal
	 */
	abstract public void outputToRule(
			Signals signals
			);
	
	/**
	 * AIւ̏o
	 */
	public void outputToAI(
			Signals signals
			) {

		try{
			//AI֓dCM𑗂
			EntranceReaction.startReaction(
					signals.getDataCooperationSignal(),
					signals.getEnvironmentSensibleSignal(),
					signals.getPhysicalSensibleSignalList());
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	protected class Signals {
		//f[^AgM
		AbstractDataCooperationSignal _dcSignal = null;
		//I̊M
		AbstractEnvironmentSensibleSignal _esSignal = null;
		//I̊M
		List<AbstractPhysicalSensibleSignal> _psSignalList = new ArrayList<AbstractPhysicalSensibleSignal>();

		public void setDataCooperationSignal(AbstractDataCooperationSignal dcSignal){
			_dcSignal = dcSignal;
		}

		public AbstractDataCooperationSignal getDataCooperationSignal(){
			return _dcSignal;
		}
		
		public void setEnvironmentSensibleSignal(AbstractEnvironmentSensibleSignal esSignal) {
			_esSignal = esSignal;
		}
		
		public AbstractEnvironmentSensibleSignal getEnvironmentSensibleSignal() {
			return _esSignal;
		}
		
		public void addPhysicalSensibleSignalList(AbstractPhysicalSensibleSignal psSignal) {
			if(_psSignalList.contains(psSignal) == false) {
				_psSignalList.add(psSignal);
			}
		}
		
		public List<AbstractPhysicalSensibleSignal> getPhysicalSensibleSignalList() {
			return _psSignalList;
		}
	}

}
