package jp.co.celestee.ai.interfaces.characterin;

import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.ai.core.signal.AbstractSignalData;
import jp.co.celestee.ai.core.signal.SignalDataIF;

/**
 * AĨf[^AgsۂɁAVOiɐݒ肷f[^łB
 * ܂\Ƃ܂B
 * @author celestee
 *
 */
public class CharacterInSignalData extends AbstractSignalData {

	private static final long serialVersionUID = 1L;

	/** ̕e\ */
	//private static final String EMPTY_CONTENTS = "";
	
	/** ̕\ */
	private static final int EMPTY_TYPE = 0;
	
	/** e  */
	private String contents = null;
	
	/** */
	private int type = 0;
	
	public CharacterInSignalData(String contents, int type) {
		this.contents = contents;
		this.type = type;
	}

	@Override
	public Class<?> getOutputIdClass() {
		return CharacterInOutputId.class;
	}
	
	public String getContents() {
		return contents;
	}

	public void setContents(String contents) {
		this.contents = contents;
	}

	public int getType() {
		return type;
	}

	public void setType(int type) {
		this.type = type;
	}

	public String toString() {
		return "(CONTENTS=" + contents + " ,TYPE=" + type + ")";
	}

	public List<SignalDataIF> getPartsSignalDataList() {
		List<SignalDataIF> signalList = new ArrayList<SignalDataIF>(3);
		
		CharacterInSignalData dataC = new CharacterInSignalData(contents, EMPTY_TYPE);
		signalList.add(dataC);

		// g (ƕe\BS̓Iɕo)
		if(contents.length() > 0) {
			CharacterInSignalData dataT = new CharacterInSignalData(
					type + ":" + contents.length() + ":" + contents.charAt(0) + ":" + contents.charAt(contents.length()-1), EMPTY_TYPE);
			signalList.add(dataT);
		}
		
		
		return signalList;
	}
	
	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b == false) return b;
		
		if(target instanceof CharacterInSignalData) {
			CharacterInSignalData data = (CharacterInSignalData)target;
			boolean bContents = contents == null ? data.getContents() == null : contents.equals(data.getContents());
			boolean btype = type == data.getType();
			return bContents && btype;
		}
		
		return false;
	}
	
	@Override
	public int hashCode() {
		return 0;
	}

	@Override
	public String getSupposingItSaysInMansWords() {
		return "hearing " + getContents();
	}

}
