package jp.co.celestee.external.event;

import jp.co.celestee.external.object.ObjectLinkManager;
import jp.co.celestee.external.object.avatar.AvatarIF;
import jp.co.celestee.external.rule.dinamic.DynamicRuleData;
import jp.co.celestee.external.virtual.AvatarMap;


/**
 * ͂̃[ɑANV܂B
 * [ɗ͂ɁȂ̂̕󂯂e\܂B
 * @author celestee
 *
 */
public class DynamicToRuleEventConveter {

	public static final int GO_ACTION = 1;
	
	public static final int TURN_RIGHT_ACTION = 2;

	public static final int LIFT_ACTION = 3;
	
	public static final int ABSORPTION_ACTION = 4;
	
	public static final int BREAK_ACTION = 5;

	public static final int TURN_LEFT_ACTION = 6;
	
	public static final int RECEIVED_ACTION = 7;

	/**
	 * Oi
	 * @param key
	 */
	public static void go(Object subStance) {
		AvatarIF avatar = ObjectLinkManager.getAvatar(subStance);
		
		if(AvatarMap.checkGo(avatar)) {
			//Oi\
			AvatarMap.go(avatar);
		}
		else {
			//Ois\
			AvatarIF frontAvatar = AvatarMap.getFrontAvatar(avatar);
			if(frontAvatar != null) {
				//Ao^[ɂĐi߂Ȃ
				if(frontAvatar.getType() == AvatarMap.OBJ_TYPE_NOT_CAN_BREAK) {
					//Ao^[ɕs^\
					return;
				}
				else {
					//Hו
					frontAvatar.addImpact(0);
				}
			}
		}
	}

	/**
	 * E]XOx
	 * @param key
	 */
	public static void turnRight(Object subStance) {
		AvatarIF avatar = ObjectLinkManager.getAvatar(subStance);
		
		avatar.turnRight();
	}
	
	/**
	 * ]XOx
	 * @param key
	 */
	public static void turnLeft(Object subStance) {
		AvatarIF avatar = ObjectLinkManager.getAvatar(subStance);
		
		avatar.turnLeft();
	}
	
	/**
	 * w̃Ao^[ɋz
	 * @param avatar
	 */
	public static void absorption(Object subStance) {
		AvatarIF avatar = ObjectLinkManager.getAvatar(subStance);
		
		AvatarIF frontAvatar = AvatarMap.getFrontAvatar(avatar);
		
		if(frontAvatar == null) {
			return;
		}
		
		if(frontAvatar.getType() == AvatarMap.OBJ_TYPE_NOT_CAN_BREAK) {
			//Ao^[ɕs^\
			return;
		}

		//ʂ̃Ao^[甭̃Ao^[֗^h
		DynamicRuleData ruleData = new DynamicRuleData();
		ruleData.setPotential(frontAvatar.getEnergy());
		ruleData.setDynamic(BREAK_ACTION);
		ruleData.setType(frontAvatar.getColor().getRGB());
		ruleData.setObject(subStance);

		frontAvatar.remove();
		
		RuleEventManager.execRuleEvent(new RuleEvent(ruleData));
	}

	/**
	 * w̃Ao^[Ɏグ
	 * @param subStance
	 */
	public static void lift(Object subStance) {
		AvatarIF avatar = ObjectLinkManager.getAvatar(subStance);
		
		AvatarIF frontAvatar = AvatarMap.getFrontAvatar(avatar);
		
		if(frontAvatar == null) {
			return;
		}
		
		if(frontAvatar.getWeight() > avatar.getWeight()) {
			//dΎグȂ
			return;
		}
		
		//ʂ̃Ao^[甭̃Ao^[֗^h
		DynamicRuleData ruleData = new DynamicRuleData();
		ruleData.setPotential(frontAvatar.getEnergy());
		ruleData.setDynamic(RECEIVED_ACTION);
		ruleData.setType(frontAvatar.getColor().getRGB());
		ruleData.setObject(subStance);

		frontAvatar.remove();
		
		RuleEventManager.execRuleEvent(new RuleEvent(ruleData));
	}

}
