package jp.co.celestee.external.object.avatar;

import java.awt.Color;
import java.awt.Point;
import java.awt.Polygon;

import jp.co.celestee.external.object.ObjectLinkManager;
import jp.co.celestee.external.virtual.AvatarMap;

/**
 * [̃IuWFNǵAK̃NXpKv܂B
 * @author celestee
 *
 */
public abstract class AbstractAvatar implements AvatarIF {

	/** ʒu */
	private Point _point = null;
	
	/** ŏ̈ʒu */
	private Point _firstPoint = null;

	/**  */
	private Point _direction = AvatarMap.DIRECTION_SOUTH;
	
	/** F */
	private Color _color = Color.white;
	
	/** ` */
	private Polygon _polygon = null;
	
	/** d */
	private int _weight = 0;
	
	/** Ao^[̐ */
	private int type = AvatarMap.OBJ_TYPE_CAN_BREAK;

	/** Ao^[̃GlM[ */
	private int _energy = 0;
	
	public AbstractAvatar(Object key) {
		ObjectLinkManager.linkObject(key, this);
	}

	public Point getFirstLocation() {
		return _firstPoint;
	}

	public Point getLocation() {
		return _point;
	}
	
	public void setLocation(Point point) {
		AvatarMap.removeAvatar(this);
		if(_point == null) {
			_firstPoint = point;
		}
		_point = point;
		AvatarMap.setAvatar(this);
	}
	
	public Point getDirection() {
		return _direction;
	}
	
	public void setDirection(Point directPoint) {
		_direction = directPoint;
	}

	public boolean isThrough() {
		return false;
	}

	public Color getColor() {
		return _color;
	}
	
	public void setColor(Color color) {
		_color = color;
	}
	
	public Polygon getPolygon() {
		return _polygon;
	}
	
	public Polygon getLookedPolygon(Point lookingPoint) {
		return _polygon;
	}

	public void setPolygon(Polygon polygon) {
		_polygon = polygon;
	}
	
	public void turnRight() {
		
		if(_direction == AvatarMap.DIRECTION_NORTH) {
			_direction = AvatarMap.DIRECTION_EAST;
		}
		else if(_direction == AvatarMap.DIRECTION_EAST) {
			_direction = AvatarMap.DIRECTION_SOUTH;
		}
		else if(_direction == AvatarMap.DIRECTION_SOUTH) {
			_direction = AvatarMap.DIRECTION_WEST;
		}
		else if(_direction == AvatarMap.DIRECTION_WEST) {
			_direction = AvatarMap.DIRECTION_NORTH;
		}
	}

	public void turnLeft() {
		
		if(_direction == AvatarMap.DIRECTION_NORTH) {
			_direction = AvatarMap.DIRECTION_WEST;
		}
		else if(_direction == AvatarMap.DIRECTION_EAST) {
			_direction = AvatarMap.DIRECTION_NORTH;
		}
		else if(_direction == AvatarMap.DIRECTION_SOUTH) {
			_direction = AvatarMap.DIRECTION_EAST;
		}
		else if(_direction == AvatarMap.DIRECTION_WEST) {
			_direction = AvatarMap.DIRECTION_SOUTH;
		}
	}

	public int getType() {
		return type;
	}
	
	public void setType(int type) {
		this.type = type;
	}
	
	public void remove() {
		AvatarMap.removeAvatar(this);
		ObjectLinkManager.remove(this);
	}

	public boolean isAcceptedLight(Point generationPoint) {
		return false;
	}

	public int getEnergy() {
		return _energy;
	}
	
	public void setEnergy(int energy) {
		_energy = energy;
	}

	public void addImpact(int impact) {
		//ʓIɂ͉܂B
	}

	public void setWeight(int weight) {
		_weight = weight;
	}
	
	public int getWeight() {
		return _weight;
	}
}
