package jp.co.celestee.external.object.avatar;

import java.awt.Color;
import java.awt.Point;

import jp.co.celestee.external.object.EnergyWhiteObj;
import jp.co.celestee.external.virtual.AvatarMap;

public class EnergyWhite extends AbstractAvatar {

	public EnergyWhite(Point location) {
		super(EnergyWhiteObj.getInstance());
		
		this.setLocation(location);
		
		@SuppressWarnings("serial")
		Color color = new Color(Color.white.getRed(), Color.white.getGreen(), Color.white.getBlue()){
			public String toString() {
				return "ENERGY_WHITE ";
			}
		};

		this.setColor(color);
		
		int[] xpoints = new int[]{14, 23, 14,  4};
		int[] ypoints = new int[]{ 4, 14, 23, 14};
		
		EnergyPolygon polygon = new EnergyPolygon(xpoints, ypoints, xpoints.length, "ENERGY_W");
		setPolygon(polygon);
		
		setType(AvatarMap.OBJ_TYPE_CAN_BREAK);
		setEnergy(12);

	}

	@Override
	public void remove() {
		super.remove();
	}
}
