package jp.co.celestee.external.rule.light;

import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.external.event.LightToRuleEventConverter;
import jp.co.celestee.external.rule.RuleAccessorIF;
import jp.co.celestee.external.rule.RuleDataIF;
import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;

public class LightRule implements RuleIF{

	public static final int LIGHT_RULE = 1;
	
	List<LightRuleAccessorIF> _list = new ArrayList<LightRuleAccessorIF>();
	
	public LightRule() {
		RuleManager ruleManager = RuleManager.getInstance();
		ruleManager.setRule(LIGHT_RULE, this);
	}
	
	/**
	 * eIF烋[ւ̓([ɑ݂Ă󂯕t镨̑SĂΏ)
	 */
	public void input(RuleDataIF ruleData) {
		LightRuleData lRuleData = (LightRuleData)ruleData;
		
		for(LightRuleAccessorIF accessIF : _list) {
			LightToRuleEventConverter.acceptedReflection(accessIF, lRuleData.getPotential());
		}
	}

	/**
	 * [eIF֏o([ɑ݂Ă镶󂯕t镨̑SĂɏo͂)
	 */
	public void output(RuleDataIF ruleData) {
		LightRuleData lRuleData = (LightRuleData)ruleData;

		//h̑MΏ
		LightRuleAccessorIF lightRuleIF = (LightRuleAccessorIF)lRuleData.getObject();
		
		if(lightRuleIF == null) {
			//h̑MΏۂȂΑSĂɍs
			for(LightRuleAccessorIF accessIF : _list) {
				accessIF.inputLight(lRuleData);
			}
		}
		else {
			//w肪ΒPɎs
			if(_list.contains(lightRuleIF)) {
				lightRuleIF.inputLight(lRuleData);
			}
			else {
				throw new UnsupportedOperationException();
			}
		}
	}
	
	public void entry(RuleAccessorIF ruleAccess) {
		_list.add((LightRuleAccessorIF)ruleAccess);
	}
	
}
