package jp.co.celestee.external.virtual;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

import jp.co.celestee.external.object.avatar.AvatarIF;

@SuppressWarnings("serial")
public class JAvatarMap extends JComponent {

	private int mapSize = AvatarMap.getMapSize();	// }ẌӁi`j
	private Color floor[][] = AvatarMap.getFloorMap();// ̐F
	private int squareWide = 32;					// }Xڂ̕
	private int margin = 20;						// [܂ōsȂ悤]T

	private Image  offScreenImg;					// ItXN[
	private Graphics grf;
   	
	private int width = mapSize * squareWide * 2;
	private int height = mapSize * squareWide * 2;

	public JAvatarMap() {
		init();
	}
	
	public void init(){
		// ItXN[̐ݒ
		//offs=createImage(n*square*2,n*square*2);
		offScreenImg = getImage();
		grf = offScreenImg.getGraphics();

	}

	public void paint(Graphics g) {
		update(g);
	}

	public void update(Graphics g){

		grf.translate(0, 0);
		grf.setColor(new Color(170, 170, 170));
		grf.fillRect(0, 0, mapSize * squareWide * 2, mapSize * squareWide * 2);

		//grf.setColor(Color.black);
		//grf.fillRect(margin,n*square+margin,n*square,20);

		//MAP̕`
		grf.setColor(Color.white);
		grf.fillRect(margin, margin, mapSize * squareWide, mapSize * squareWide);
		grf.setColor(Color.white);
		for(int i = 0; i < mapSize + 2; i++){
			grf.drawLine(i * squareWide + margin, margin, i * squareWide + margin, (mapSize + 1) * squareWide + margin);
			grf.drawLine(margin, i * squareWide + margin, (mapSize + 1) * squareWide + margin, i * squareWide + margin);
		}
		
		//Ղ̕`
		int xx,yy;		//}X̍W 
		xx = mapSize * squareWide + margin;
		for(int i = 1; i < mapSize + 1; i++) {
			yy = i * squareWide + margin;
			grf.drawString(String.valueOf(i - 1), xx + 12, yy - 12);
		}
		yy = (mapSize + 1) * squareWide + margin;
		for(int i = 0; i < mapSize; i++) {
			xx = i * squareWide + margin;
			grf.drawString(String.valueOf(i), xx + 12, yy - 12);
		}
		
		// ̕`
		for(int y=0; y < mapSize; y++){
			yy = y * squareWide + margin;
			for(int x = 0; x < mapSize; x++){
				xx = x * squareWide + margin;

				grf.setColor(floor[x][y]);
				grf.fillRect(xx + 1, yy + 1, 31, 31);
				//grf.drawOval(xx + innerMargin, yy + innerMargin, rad, rad);
			}
		}
		
		//Ao^[̕`
		for(int y=0; y < mapSize; y++){
			yy = y * squareWide + margin;
			for(int x = 0; x < mapSize; x++){
				xx = x * squareWide + margin;

				AvatarIF avatar = AvatarMap.getAvatar(x, y);
				
				if(avatar != null) {
					grf.translate(xx + 3, yy + 3);
					grf.setColor(avatar.getColor());
					grf.fillPolygon(avatar.getPolygon());
					grf.translate(-(xx + 3), -(yy + 3));
				}
			}
		}
		
		// ItXN[̃C[WꋓɎۂ̕\̈ɕ`
		g.drawImage(offScreenImg, 0, 0, this);	

	}

	BufferedImage getImage() {
		
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		Graphics g = bi.createGraphics();
		paintComponent(g);
		return bi;
	}
	
	void setImage(Image img) {
		offScreenImg = img;
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		if(offScreenImg != null){
			int w = offScreenImg.getWidth(this);
			int h = offScreenImg.getHeight(this);
			if(w != width || h != height){
				width = w;
				height = h;
				this.setPreferredSize(new Dimension(width, height));
			}
			g.drawImage(offScreenImg, 0, 0, this);
		}
	}

}
