package jp.co.celestee.ai.main;

import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.ai.core.embed.PhysicalDesirePreInstaller;
import jp.co.celestee.ai.core.factory.PhysicalDesireFactory;
import jp.co.celestee.ai.interfaces.EntranceReaction;
import jp.co.celestee.ai.interfaces.body.BodySubstance;
import jp.co.celestee.ai.interfaces.body.id.BodyEatId;
import jp.co.celestee.ai.interfaces.body.id.BodyPickupId;
import jp.co.celestee.ai.interfaces.body.id.BodyTurnLeftId;
import jp.co.celestee.ai.interfaces.body.id.BodyTurnRightId;
import jp.co.celestee.ai.interfaces.body.id.BodyWalkId;
import jp.co.celestee.ai.interfaces.constant.PhysicalDesireConst;
import jp.co.celestee.ai.interfaces.input.AbstractPhysicalSensibleSignal;
import jp.co.celestee.ai.interfaces.status.JStatusFrame;
import jp.co.celestee.ai.interfaces.status.StatusWatcher;

public class MainClass {

	public static void main(String args[]) {
		
		//~̓o^
		PhysicalDesireFactory.createAndManage(new BodyWalkId(), PhysicalDesireConst.WALK_DESIRE);
		PhysicalDesireFactory.createAndManage(new BodyTurnRightId(), PhysicalDesireConst.TURN_RIGHT_DESIRE);
		PhysicalDesireFactory.createAndManage(new BodyTurnLeftId(), PhysicalDesireConst.TURN_LEFT_DESIRE);
		PhysicalDesireFactory.createAndManage(new BodyEatId(), PhysicalDesireConst.EAT_DESIRE);
		PhysicalDesireFactory.createAndManage(new BodyPickupId(), PhysicalDesireConst.PICKUP_DESIRE);

		//~̓̃vCXg[
		List<Long> installList = new ArrayList<Long>();
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.TURN_LEFT_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.TURN_RIGHT_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.EAT_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.WALK_DESIRE);
		installList.add(PhysicalDesireConst.PICKUP_DESIRE);
		PhysicalDesirePreInstaller.setPhysicalDesireNerveList(installList);
		
		//̕I~ʒmĂ
		List<AbstractPhysicalSensibleSignal> psSignalList = BodySubstance.getInstance().getPhysicalSensibleSignalList();
		try {
			EntranceReaction.startReaction(null, null, psSignalList);
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		
		//AĨXe[^XĎ
		new JStatusFrame();
		StatusWatcher statusWatcher = new StatusWatcher();
		statusWatcher.start();
		
		SmallWorldBuilder.buildWorld();
		
	}
}
